Bug 1348532 - pyliblo: python2-pyliblo requires both Python 2 and Python 3 [NEEDINFO]
Summary: pyliblo: python2-pyliblo requires both Python 2 and Python 3
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: pyliblo
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Fabian Affolter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3 PY3PATCH-PUSH PYTHON3-PYTHON2
TreeView+ depends on / blocked
 
Reported: 2016-06-21 12:02 UTC by Dominika Krejčí
Modified: 2016-09-09 21:46 UTC (History)
4 users (show)

Fixed In Version: pyliblo-0.10.0-2.fc24 pyliblo-0.10.0-2.fc23 pyliblo-0.10.0-4.fc25
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-09-09 21:46:53 UTC
torsava: needinfo? (mail)


Attachments (Terms of Use)
fix of Python3 dependencies (1.44 KB, patch)
2016-07-18 11:37 UTC, Dominika Krejčí
no flags Details | Diff
Fix shebang and command line utils (3.25 KB, patch)
2016-08-30 13:08 UTC, Lumír Balhar
no flags Details | Diff

Description Dominika Krejčí 2016-06-21 12:02:52 UTC
The python2-pyliblo RPM requires both Python 2 and Python 3.

Except in very special circumstances, there is no need for one package
to drag in both Python stacks. Usually, this is a packaging error: for
example, a stray "/usr/bin/python" shebang in a Python 3 package can
introduce a Python 2 dependency.

Please split your package, or remove the stray dependencies.
There is a section on shebangs in the Python RPM Porting Guide [0]
which covers this issue.

It's ok to do this in Rawhide only, however, it would be greatly
appreciated if you could push it to Fedora 24 as well.


If anything is unclear, or if you need any kind of assistance, you can
ask on IRC (#fedora-python on Freenode), or reply here. We'll be happy
to help investigating or fixing this issue!


[0] http://python-rpm-porting.readthedocs.io/en/latest/application-modules.html#are-shebangs-dragging-you-down-to-python-2

Comment 1 Fedora Update System 2016-06-27 16:02:43 UTC
pyliblo-0.10.0-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-6fcc611baf

Comment 2 Fedora Update System 2016-06-27 16:23:09 UTC
pyliblo-0.10.0-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-87d30cf035

Comment 3 Fedora Update System 2016-06-28 00:26:29 UTC
pyliblo-0.10.0-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-87d30cf035

Comment 4 Fedora Update System 2016-06-28 04:24:17 UTC
pyliblo-0.10.0-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-6fcc611baf

Comment 5 Fedora Update System 2016-07-10 05:58:49 UTC
pyliblo-0.10.0-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 6 Dominika Krejčí 2016-07-11 12:56:20 UTC
python2-pyliblo still depends on Python3.

Comment 7 Fedora Update System 2016-07-15 10:23:58 UTC
pyliblo-0.10.0-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 8 Dominika Krejčí 2016-07-18 11:37:11 UTC
Created attachment 1181024 [details]
fix of Python3 dependencies

This patch should solve the problem mentioned before.

Comment 9 Jan Kurik 2016-07-26 04:38:53 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.

Comment 10 Lumír Balhar 2016-08-30 07:18:54 UTC
Hello Dominiko.

I've found that with your patch there is issue with Python 2 package, because it depends on /usr/bin/python3

$ rpm -qp --requires ~/rpmbuild/RPMS/python2-pyliblo-0.10.0-4.fc26.x86_64.rpm 
/usr/bin/python3
libc.so.6()(64bit)
libc.so.6(GLIBC_2.2.5)(64bit)
libc.so.6(GLIBC_2.4)(64bit)
liblo.so.7()(64bit)
libpthread.so.0()(64bit)
libpython2.7.so.1.0()(64bit)
python(abi) = 2.7
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(PayloadIsXz) <= 5.2-1
rtld(GNU_HASH)

I think that problematic files are in /usr/bin.

Comment 11 Lumír Balhar 2016-08-30 13:08:09 UTC
Created attachment 1195902 [details]
Fix shebang and command line utils

Hello.

I am providing new patch for fix the problem with dependency on two versions of Python.

What we had to do:
- Remove command line utils from python2 package. Command line utils are now only in python3 package with python3 shebang. Nothing currently depends on pyliblo so it's clear solution. If some package will depend on this utils in future, it will get python3 version of pyliblo package.
- Remove exec bit and shebang from examples script. This change brings possibility to package this documentation scripts in both subpackages.

What do you think about it?

Koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=15437485

Comment 12 Tomas Orsava 2016-08-30 14:25:50 UTC
Hi Lumir!

That patch looks good to me and the resulting RPMs check out, good work!

Comment 13 Tomas Orsava 2016-08-30 14:26:37 UTC
Hi Fabian,
as this is a bit of a time sensitive issue, we would really appreciate if you could take a look at the patch as soon as possible.
If you are time constrained right now, I hope you won't mind if we do the review and push the changes ourselves in case you are unable.

Thank you!

Comment 14 Fedora Update System 2016-09-07 12:29:27 UTC
pyliblo-0.10.0-4.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-6be3544d0b

Comment 15 Fedora Update System 2016-09-09 06:27:44 UTC
pyliblo-0.10.0-4.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-6be3544d0b

Comment 16 Fedora Update System 2016-09-09 21:46:49 UTC
pyliblo-0.10.0-4.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.